Package: seasonalityPlot
Type: Package
Title: Seasonality Variation Plots of Stock Prices and Cryptocurrencies
Version: 1.3.1
Authors@R: c(person("Satoshi", "Kume", 
             role = c("aut", "cre"),
             email = "satoshi.kume.1984@gmail.com"))
Description: The price action at any given time is determined by investor 
  sentiment and market conditions. Although there is no established principle, 
  over a long period of time, things often move with a certain periodicity.
  This is sometimes referred to as anomaly. 
  The seasonPlot() function in this package calculates and visualizes the 
  average value of price movements over a year for any given period. 
  In addition, the monthly increase or decrease in price movement is 
  represented with a colored background. 
  This seasonPlot() function can use the same symbols as the 'quantmod' package 
  (e.g. ^IXIC, ^DJI, SPY, BTC-USD, and ETH-USD etc). 
Depends: R (>= 4.0.0)
Imports: magrittr, quantmod, dygraphs, plotrix, htmltools, grDevices,
        graphics, zoo, lubridate, crypto2, TTR, assertthat
Suggests: testthat
License: Artistic-2.0
Encoding: UTF-8
URL: https://github.com/kumeS/seasonalityPlot,
        https://kumes.github.io/seasonalityPlot/,
        https://skume-seasonalityplot.hf.space/__docs__/#/
BugReports: https://github.com/kumeS/seasonalityPlot/issues
RoxygenNote: 7.2.3
NeedsCompilation: no
Packaged: 2024-09-25 09:42:17 UTC; sas
Author: Satoshi Kume [aut, cre]
Maintainer: Satoshi Kume <satoshi.kume.1984@gmail.com>
Repository: CRAN
Date/Publication: 2024-09-25 12:00:02 UTC
Built: R 4.6.0; ; 2026-04-26 00:58:13 UTC; unix

Package: seasonalityPlot
Type: Package
Title: Seasonality Variation Plots of Stock Prices and Cryptocurrencies
Version: 1.3.1
Authors@R: c(person("Satoshi", "Kume", 
             role = c("aut", "cre"),
             email = "satoshi.kume.1984@gmail.com"))
Description: The price action at any given time is determined by investor 
  sentiment and market conditions. Although there is no established principle, 
  over a long period of time, things often move with a certain periodicity.
  This is sometimes referred to as anomaly. 
  The seasonPlot() function in this package calculates and visualizes the 
  average value of price movements over a year for any given period. 
  In addition, the monthly increase or decrease in price movement is 
  represented with a colored background. 
  This seasonPlot() function can use the same symbols as the 'quantmod' package 
  (e.g. ^IXIC, ^DJI, SPY, BTC-USD, and ETH-USD etc). 
Depends: R (>= 4.0.0)
Imports: magrittr, quantmod, dygraphs, plotrix, htmltools, grDevices,
        graphics, zoo, lubridate, crypto2, TTR, assertthat
Suggests: testthat
License: Artistic-2.0
Encoding: UTF-8
URL: https://github.com/kumeS/seasonalityPlot,
        https://kumes.github.io/seasonalityPlot/,
        https://skume-seasonalityplot.hf.space/__docs__/#/
BugReports: https://github.com/kumeS/seasonalityPlot/issues
RoxygenNote: 7.2.3
NeedsCompilation: no
Packaged: 2024-09-25 09:42:17 UTC; sas
Author: Satoshi Kume [aut, cre]
Maintainer: Satoshi Kume <satoshi.kume.1984@gmail.com>
Repository: CRAN
Date/Publication: 2024-09-25 12:00:02 UTC
Built: R 4.6.0; ; 2026-04-30 03:09:15 UTC; unix

# [seasonalityPlot package](https://github.com/kumeS/seasonalityPlot)
 <img src="https://github.com/kumeS/seasonalityPlot/blob/main/inst/images/hexSticker_seasonalityPlot.png" align="right" height="139" />

[![CRAN](https://www.r-pkg.org/badges/version/seasonalityPlot)](https://CRAN.R-project.org/package=seasonalityPlot)
[![CRAN_latest_release_date](https://www.r-pkg.org/badges/last-release/seasonalityPlot)](https://cran.r-project.org/package=seasonalityPlot)
[![CRAN](https://cranlogs.r-pkg.org/badges/grand-total/seasonalityPlot)](https://www.datasciencemeta.com/rpackages)
[![CRAN downloads last month](https://cranlogs.r-pkg.org/badges/seasonalityPlot)](https://cran.r-project.org/package=seasonalityPlot)
[![CRAN downloads last week](https://cranlogs.r-pkg.org:443/badges/last-week/seasonalityPlot)](https://cranlogs.r-pkg.org:443/badges/last-week/seasonalityPlot)

R package for Creating Seasonality Plots of Stock Prices and Cryptocurrencies

# Description

The price action at any given time is determined by investor sentiment and market conditions. Although there is no established principle, over a long period of time, things often move with a certain periodicity. This is sometimes referred to as anomaly. The seasonPlot() function in this package calculates and visualizes the average value of price movements over a year for any given period. In addition, the monthly increase or decrease in price movement is represented with a colored background. This seasonPlot() function can use the same symbols as the 'quantmod' package (e.g. ^IXIC, ^DJI, SPY, BTC-USD, and ETH-USD etc).

## Documents and Web API

- [GitHub.io/seasonalityPlot](https://kumes.github.io/seasonalityPlot/)

- [Huggingface Spaces/seasonalityPlot API via Plumber](https://skume-seasonalityplot.hf.space/__docs__/#/)

# Version

1.3.1: Modify the "CryptoRSIheatmap" function (CRAN 4th version) and build the seasonalityPlot Web API on Huggingface Spaces.

1.2.1: Update seasonPlot & Add new function "CryptoRSIheatmap".

1.1.1: Update Figures.

1.1.0: CRAN 3rd version.

1.0.1: CRAN 2nd version.

0.99.3: CRAN version.

0.99.1: Newly Published the GitHub.

# Installation

### install from CRAN

```r
install.packages("seasonalityPlot", repos="http://cran.r-project.org")
```

### install the latest from GitHub

type the code below in the R console window

```r
install.packages("devtools", repos="http://cran.r-project.org")
library(devtools)
devtools::install_github("kumeS/seasonalityPlot")
```

or install from the source file with `sh` commands

```sh
git clone https://github.com/kumeS/seasonalityPlot.git
R CMD INSTALL seasonalityPlot
```

# Function

- seasonPlot: create seasonality plots for stock prices or cryptocurrencies

- CryptoRSIheatmap: CryptoRSI Heatmap Function

# Usage of seasonPlot function

```r
library(seasonalityPlot)

#Plot an averaging seasonality of SPDR S&P500 ETF (SPY) between 2012 and 2022.
seasonPlot(Symbols="SPY")

#useAdjusted = TRUE
seasonPlot(Symbols="SPY", useAdjusted = TRUE)
```

<div style="text-align: center">
  <img src="inst/images/SeasonalityPlot_SPY_StartYear2012_EndYear2022.png" width="750px">
</div>

```r
#Plot an averaging seasonality of Dow Jones Industrial Average (^DJI) between 2012 and 2022.
seasonPlot(Symbols="^DJI")
```

<div style="text-align: center">
  <img src="inst/images/SeasonalityPlot_^DJI_StartYear2012_EndYear2022.png" width="750px">
</div>

```r
#Plot an averaging seasonality of NASDAQ Composite (^IXIC) between 2012 and 2022.
seasonPlot(Symbols="^IXIC")
```

<div style="text-align: center">
  <img src="inst/images/SeasonalityPlot_^IXIC_StartYear2012_EndYear2022.png" width="750px">
</div>

```r
#Plot an averaging seasonality of Bitcoin (BTC-USD) between 2017 and 2022.
seasonPlot(Symbols="BTC-USD")
```

<div style="text-align: center">
  <img src="inst/images/SeasonalityPlot_BTC-USD_StartYear2017_EndYear2022.png" width="750px">
</div>

```r
#Plot an averaging seasonality of Ethereum (ETH-USD) between 2017 and 2022.
seasonPlot(Symbols="ETH-USD")
```

<div style="text-align: center">
  <img src="inst/images/SeasonalityPlot_ETH-USD_StartYear2017_EndYear2022.png" width="750px">
</div>

```r
#CryptoRSI Heatmap Function provides a heatmap visualization of RSI values for a specified number of cryptocurrencies.

CryptoRSIheatmap(coin_num = 200, useRank = 1000, n = 21, useRankPlot = TRUE, OutputData = FALSE)
```

<div style="text-align: center">
  <img src="inst/images/CryptoRSIheatmap.png" width="750px">
</div>

# License

Copyright (c) 2021 Satoshi Kume 

Released under the [Artistic License 2.0](http://www.perlfoundation.org/artistic_license_2_0).

# Authors

- Satoshi Kume

#' RSI Divergence Detection Function
#'
#' This function calculates the Relative Strength Index (RSI) and detects divergences between the RSI and price data. 
#' It identifies bullish and bearish divergences as well as pivot points. 
#' The results are visualized using `googleVis::gvisLineChart`.
#'
#' @param data An `xts` or `zoo` object containing the financial time series data. It must include the closing prices.
#' @param len Integer. The lookback period for calculating the RSI. Default is 14.
#' @param ob Numeric. The overbought threshold for RSI. Default is 70.
#' @param os Numeric. The oversold threshold for RSI. Default is 30.
#' @param omid Numeric. The midline value for RSI. Default is 50.
#' @param xbars Integer. The number of past bars (periods) to look back for divergence detection. Default is 90.
#' @param short_labels Logical. If `TRUE`, labels on the charts will be shortened. Currently not implemented. Default is `FALSE`.
#'
#' @importFrom quantmod
#' @importFrom googleVis 
#' @importFrom TTR
#' @importFrom magrittr 
#' 
#' @export RSIdivergencePlot
#' 
#' @return A list containing the following elements:
#' \item{plot_data}{A data frame with the calculated RSI values and identified divergences and pivots.}
#' \item{rsi_chart}{An interactive RSI chart object created by `googleVis::gvisLineChart`.}
#' \item{price_chart}{An interactive price chart object created by `googleVis::gvisLineChart`.}
#'
#' @examples
#' \dontrun{
#' 
#' result <- RSIdivergencePlot(Symbol="BTC-USD")
#' 
#' }
#' 

#BTC-USD (Bitcoin)
BTC <- list(
Symbols="BTC-USD",
StartYear=2015,
EndYear=2020,
LineColor=1,
xlab="Month",
BackgroundMode=TRUE,
alpha=0.05,
OutputData=FALSE,
Save=FALSE,
output_width=1000,
output_height=700,
family="Helvetica",
PlotAll=FALSE
)

#attach(BTC)

#SPY (SPDR S&P500 ETF)
SPY <- list(
Symbols="SPY",
StartYear=2010,
EndYear=2020,
LineColor=1,
xlab="Month",
BackgroundMode=TRUE,
alpha=0.05,
OutputData=FALSE,
Save=FALSE,
output_width=1000,
output_height=700,
family="Helvetica",
PlotAll=FALSE
)

#attach(SPY)

#^DJI (Dow Jones Industrial Average)
DJI <- list(
Symbols="^DJI",
StartYear=2010,
EndYear=2020,
LineColor=1,
xlab="Month",
BackgroundMode=TRUE,
alpha=0.05,
OutputData=FALSE,
Save=FALSE,
output_width=1000,
output_height=700,
family="Helvetica",
PlotAll=FALSE
)

#attach(DJI)

#' CryptoRSI Heatmap
#'
#' Generates a heatmap of the Relative Strength Index (RSI) for a randomly selected
#' subset of cryptocurrencies. This function leverages the `crypto2` and `TTR`
#' packages to fetch cryptocurrency data and calculate RSI values, respectively.
#' The heatmap visualizes RSI values to identify potential overbought or oversold
#' conditions in the crypto market.
#'
#' @title CryptoRSI Heatmap Function
#' @description This function provides a heatmap visualization of RSI values for
#'  a specified number of cryptocurrencies. Selected randomly based on their market
#'  cap ranking, it aims to offer insights into the current market sentiment.
#' @param coin_num An integer specifying the number of coins to display in the heatmap.
#' @param useRank An integer defining the range within which coins are randomly
#'  selected based on their market cap ranking.
#' @param n An integer indicating the number of periods for calculating moving
#'  averages in the RSI computation.
#' @param useRankPlot A boolean that determines if the x-axis should plot ranks
#'  instead of sequential numbers.
#' @param OutputData A boolean that decides if the function should return the final
#'  plot data table.
#'
#' @importFrom crypto2 crypto_list crypto_history
#' @importFrom TTR RSI
#' @importFrom assertthat assert_that
#' @importFrom stats median
#'
#' @return If `OutputData` is TRUE, returns a data frame with symbols,
#'  ranks (or sequential numbers), RSI values, and colors for plotting.
#'  Otherwise, displays a heatmap plot.
#'
#' @export CryptoRSIheatmap
#' @author Satoshi Kume
#'
#' @examples
#' \dontrun{
#' CryptoRSIheatmap(coin_num = 200, useRank = 1000, n = 21,
#'         useRankPlot = TRUE, OutputData = FALSE)
#'}
#'

CryptoRSIheatmap <- function(coin_num = 200, useRank = 1000, n = 21, useRankPlot = TRUE,
                             OutputData = FALSE){

assertthat::assert_that(coin_num < useRank, msg = "coin_num must be less than useRank")

cat("Obtaining the crypto_list... \n")
coins <- crypto2::crypto_list(only_active=TRUE)

#str(coins)
coins <- coins[order(coins$rank),]
coins <- coins[1:useRank,]

res <- sample(nrow(coins), size = coin_num, replace = FALSE)
coins.res <- coins[res[order(res)],]

cat("Obtaining the crypto_history... \n")
coin_hist <- crypto2::crypto_history(coins.res,
                                     start_date=gsub("-", "", lubridate::date(Sys.Date())-n-10),
                                     end_date=gsub("-", "", lubridate::date(Sys.Date())-1))
coin.df <- data.frame(coin_hist)
#head(coin.df); str(coin.df)

results <- data.frame(matrix(NA, nrow=coin_num, ncol=4))
results$X1 <- coins.res$symbol
results$X2 <- seq_len(coin_num)
results$X3 <- coins.res$rank

for(k in seq_len(nrow(coins.res))){
  #k <- 1
  a <- coins.res$symbol[k]
  b <- coin.df[coin.df$symbol == a,]
  if(nrow(b) >= n+5){
  d <- round(TTR::RSI(as.numeric(b$close), n = n), 2)
  results[grepl(coins.res$symbol[k],results$X1),4] <- d[length(d)]
  }
}

#Remove NA
#table(is.na(results$X4))
results <- results[!is.na(results$X4),]
colnames(results) <- c("Symbol", "No", "Rank", "ClosePrice")

if(useRankPlot){
results.u <- results[,-2]
XYlab <- c("Rank", "ClosePrice")
}else{
results.u <- results[,-3]
XYlab <- c("No", "ClosePrice")
}
colnames(results.u) <- c("Symbol", "X", "Y")

#Setting
UpperLimit <- 85
OVERBOUGHT <- 70
STRONG <- 60
NEUTRAL <- 50
WEAK <- 40
OVEZRSOLD <- 30
LowerLimit <- 15
x1 <- 0
x2 <- max(results.u$X)+1
p <- 3

#Normalized
results.u$Y[results.u$Y > UpperLimit] <- UpperLimit
results.u$Y[results.u$Y < LowerLimit] <- LowerLimit

#Color
results.u$COL <- NA
#head(results.u)
results.u$COL <- "#FF000095"
results.u$COL[results.u$Y < OVERBOUGHT] <- "#FF000040"
results.u$COL[results.u$Y < STRONG] <- "#7E7E7E30"
results.u$COL[results.u$Y < WEAK] <- "#0072FF40"
results.u$COL[results.u$Y < OVEZRSOLD] <- "#0072FF95"

#Plot
oldpar <- graphics::par(no.readonly = TRUE)
on.exit(graphics::par(oldpar))
pp <- round(x2*0.01,0)

par(family= "HiraKakuPro-W3", xpd =F, mar=c(5,4,3,2))
plot(results.u$X, results.u$Y,
     ylim = c(LowerLimit-p, UpperLimit+p),
     xlim = c(x1, x2+pp),
     xlab = XYlab[1], ylab = XYlab[2],
     type = "b", col = "white",
     #xaxt = "n",
     yaxt = "n",
     cex.lab=1.25,
     main = paste0("CryptoRSI Heatmap: ", nrow(results.u), " coins"),
     xaxs="i", yaxs="i")

#X-axis: No-setting
#Y-axis
lab <- c(LowerLimit, OVEZRSOLD, WEAK, NEUTRAL, STRONG, OVERBOUGHT, UpperLimit)
axis(2, at = lab, labels = F)
text(par("usr")[1]-5, lab, labels = lab, srt = 0, pos = 2, xpd = TRUE, cex=1)

#Polygon zone
polygon( c(x1:(x2+pp), rev(x1:(x2+pp))),
         c(rep(LowerLimit-p, length(x1:(x2+pp))), rep(OVEZRSOLD, length(x1:(x2+pp)))),
         col="#0072FF30", border = NA)
polygon( c(x1:(x2+pp), rev(x1:(x2+pp))),
         c(rep(OVEZRSOLD, length(x1:(x2+pp))), rep(WEAK, length(x1:(x2+pp)))),
         col="#0072FF15", border = NA)
polygon( c(x1:(x2+pp), rev(x1:(x2+pp))),
         c(rep(STRONG, length(x1:(x2+pp))), rep(OVERBOUGHT, length(x1:(x2+pp)))),
         col="#FF000010", border = NA)
polygon( c(x1:(x2+pp), rev(x1:(x2+pp))),
         c(rep(OVERBOUGHT, length(x1:(x2+pp))), rep(UpperLimit+p, length(x1:(x2+pp)))),
         col="#FF000020", border = NA)

#Median line
abline(h=stats::median(results.u$Y), lwd=2, lty=2, col="grey")

#Plot points
points(results.u$X, results.u$Y,
       col=results.u$COL, bg=results.u$COL, pch=21, cex=1.25)

#Output
if(OutputData){
return(results.u)
}

}

library(hexSticker)

imgurl <- system.file("/inst/images/SeasonalityPlot_BTC-USD_StartYear2014_EndYear2020.png",
                      package="seasonalityPlot")
sticker(imgurl, package="seasonalityPlot", p_size=30, s_x=1, s_y=.78, s_width=.58,
        filename="./seasonalityPlot/inst/images/hexSticker_seasonalityPlot.png",
        dpi = 500)

#coin_Rank <- readRDS("./seasonalityPlot-main/inst/extdata/coin_Rank.Rds")
coin_Rank.df <- data.frame(coin_Rank)
head(coin_Rank.df)

coin_Rank.df.mc <- coin_Rank.df[order(-coin_Rank.df$market_cap),]
head(coin_Rank.df.mc)
row.names(coin_Rank.df.mc) <- 1:nrow(coin_Rank.df.mc)
#colnames(coin_Rank.df.mc)
coin_Rank.df.mc.v2 <- coin_Rank.df.mc[,c("id","slug","name","symbol","timestamp","ref_cur_id","ref_cur_name","close","volume","market_cap")]
head(coin_Rank.df.mc.v2)
saveRDS(coin_Rank.df.mc.v2, file="coin_Rank_v2.Rds")
